VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "CheckIco"
   ClientHeight    =   1245
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   2130
   LinkTopic       =   "Form1"
   ScaleHeight     =   1245
   ScaleWidth      =   2130
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdVerify 
      Caption         =   "Verify"
      Height          =   495
      Left            =   480
      TabIndex        =   0
      Top             =   360
      Width           =   1215
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Type Point
    Name As String
    X As Single
    Y As Single
    Z As Single
End Type

Private Type Edge
    Pt1 As Integer
    Pt2 As Integer
End Type

Private Type Face
    Pt1 As Integer
    Pt2 As Integer
    Pt3 As Integer
End Type

Private Type Triangle
    Pt1 As Integer
    Pt2 As Integer
    Pt3 As Integer
End Type

Private m_Points() As Point
Private m_Edges() As Edge
Private m_Faces() As Face
Private m_Triangles() As Triangle

Private Z1 As Single

Private Function FindPointByName(ByVal point_name As String) As Integer
Dim i As Integer

    For i = 1 To UBound(m_Points)
        If m_Points(i).Name = point_name Then
            FindPointByName = i
            Exit For
        End If
    Next i
End Function

' Create a geodesic tiling for this face.
Private Sub TileFace(the_face As Face)
Const LEVEL = 2

Dim x0 As Single
Dim y0 As Single
Dim z0 As Single
Dim v1x As Single
Dim v1y As Single
Dim v1z As Single
Dim v2x As Single
Dim v2y As Single
Dim v2z As Single
Dim base_name As String
Dim p10 As Integer
Dim p01 As Integer
Dim p11 As Integer

    ' Get the Face's origin.
    With m_Points(the_face.Pt1)
        x0 = .X
        y0 = .Y
        z0 = .Z
    End With

    ' Get the tiling's generating vectors.
    v1x = (m_Points(the_face.Pt2).X - m_Points(the_face.Pt1).X) / LEVEL
    v1y = (m_Points(the_face.Pt2).Y - m_Points(the_face.Pt1).Y) / LEVEL
    v1z = (m_Points(the_face.Pt2).Z - m_Points(the_face.Pt1).Z) / LEVEL
    v2x = (m_Points(the_face.Pt3).X - m_Points(the_face.Pt1).X) / LEVEL
    v2y = (m_Points(the_face.Pt3).Y - m_Points(the_face.Pt1).Y) / LEVEL
    v2z = (m_Points(the_face.Pt3).Z - m_Points(the_face.Pt1).Z) / LEVEL

    ' Generate the points.
    base_name = _
        Format$(the_face.Pt1) & "-" & _
        Format$(the_face.Pt2) & "-" & _
        Format$(the_face.Pt1) & ":"
    p10 = MakeNormalizedPoint(base_name & "1,0", x0 + v1x, y0 + v1y, z0 + v1z)
    p01 = MakeNormalizedPoint(base_name & "0,1", x0 + v2x, y0 + v2y, z0 + v2z)
    p11 = MakeNormalizedPoint(base_name & "1,1", x0 + v1x + v2x, y0 + v1y + v2y, z0 + v1z + v2z)

    ' Make the triangles.
    MakeTriangle the_face.Pt1, p10, p01
    MakeTriangle p10, p11, p01
    MakeTriangle p10, the_face.Pt2, p11
    MakeTriangle p01, p11, the_face.Pt3
End Sub
Private Sub cmdVerify_Click()
Const Pi = 3.14159265
Const S = 100#

Dim t1 As Single
Dim t2 As Single
Dim t3 As Single
Dim t4 As Single
Dim R As Single
Dim H As Single
Dim Cx As Single
Dim Cy As Single
Dim H1 As Single
Dim H2 As Single
Dim Z2 As Single

Dim i As Integer

    ' Calculate intermediate values.
    t1 = 2 * Pi / 5
    t2 = Pi / 10
    t4 = Pi / 5
    t3 = -3 * Pi / 10
    R = (S / 2) / Sin(t4)
    H = Cos(t4) * R
    Cx = R * Cos(t2)
    Cy = R * Sin(t2)
    Z2 = 1
    H1 = Sqr(S * S - R * R)
    H2 = Sqr((H + R) * (H + R) - H * H)
    Z2 = (H2 - H1) / 2
    Z1 = Z2 + H1

    ' Create the points.
    MakePoint "a", 0, 0, Z1
    MakePoint "b", 0, R, Z2
    MakePoint "c", Cx, Cy, Z2
    MakePoint "d", S / 2, -H, Z2
    MakePoint "e", -S / 2, -H, Z2
    MakePoint "f", -Cx, Cy, Z2
    MakePoint "g", 0, -R, -Z2
    MakePoint "h", -Cx, -Cy, -Z2
    MakePoint "i", -S / 2, H, -Z2
    MakePoint "j", S / 2, H, -Z2
    MakePoint "k", Cx, -Cy, -Z2
    MakePoint "l", 0, 0, -Z1

    ' Make the outwardly-oriented faces.
    MakeFace "a", "c", "b"
    MakeFace "a", "b", "f"
    MakeFace "a", "f", "e"
    MakeFace "a", "e", "d"
    MakeFace "a", "d", "c"
    MakeFace "c", "d", "k"
    MakeFace "c", "k", "j"
    MakeFace "c", "j", "b"
    MakeFace "b", "j", "i"
    MakeFace "b", "i", "f"
    MakeFace "f", "i", "h"
    MakeFace "f", "h", "e"
    MakeFace "e", "h", "g"
    MakeFace "e", "g", "d"
    MakeFace "d", "g", "k"
    MakeFace "l", "j", "k"
    MakeFace "l", "k", "g"
    MakeFace "l", "g", "h"
    MakeFace "l", "h", "i"
    MakeFace "l", "i", "j"

    ' Make geodesic tilings of the faces.
    For i = 1 To UBound(m_Faces)
        TileFace m_Faces(i)
    Next i

    ' Write Face information into a file.
    Dim file_name As String
    Dim fnum As Integer
    Dim txt As String
    Dim txt2 As String

    file_name = App.Path
    If Right$(file_name, 1) <> "\" Then file_name = file_name & "\"
    file_name = file_name & "geodesic.txt"
    fnum = FreeFile
    Open file_name For Output As #fnum
    txt2 = _
        "  0.1, 0.6, 0.1, ' Ambient." & vbCrLf & _
        "  0.1, 0.6, 0.1, ' Diffuse." & vbCrLf & _
        "  10, 0.3,       ' Specular." & vbCrLf & _
        "  0, 0, 0,       ' Reflected." & vbCrLf & _
        "  1, 1, 1,       ' TransN, n1, n2." & vbCrLf & _
        "  0, 0, 0        ' Tansmission." & vbCrLf & _
        ")"

'    ' Make faces for the polyhedron.
'    For i = 1 To UBound(m_Faces)
'        txt = "Face(3," & vbCrLf
'        With m_Points(m_Faces(i).Pt3)
'            txt = txt & "  " & .X & ", " & -.Y & ", " & .Z & ", ' Point 1" & vbCrLf
'        End With
'        With m_Points(m_Faces(i).Pt2)
'            txt = txt & "  " & .X & ", " & -.Y & ", " & .Z & ", ' Point 2" & vbCrLf
'        End With
'        With m_Points(m_Faces(i).Pt1)
'            txt = txt & "  " & .X & ", " & -.Y & ", " & .Z & ", ' Point 3" & vbCrLf
'        End With
'        Print #fnum, txt & txt2
'    Next i

    ' Make faces for the triangles.
    For i = 1 To UBound(m_Triangles)
        txt = "Face(3," & vbCrLf
        With m_Points(m_Triangles(i).Pt1)
            txt = txt & "  " & .X & ", " & .Y & ", " & .Z & ", ' Point 1" & vbCrLf
        End With
        With m_Points(m_Triangles(i).Pt2)
            txt = txt & "  " & .X & ", " & .Y & ", " & .Z & ", ' Point 2" & vbCrLf
        End With
        With m_Points(m_Triangles(i).Pt3)
            txt = txt & "  " & .X & ", " & .Y & ", " & .Z & ", ' Point 3" & vbCrLf
        End With
        Print #fnum, txt & txt2
    Next i
    Close #fnum

    MsgBox "Created " & UBound(m_Triangles) & " triangles"
End Sub
' Add an edge to the m_Edges array.
Private Sub MakeEdge(ByVal name1 As String, ByVal name2 As String)
Dim num_edges As Integer

    ' Make room.
    On Error Resume Next
    num_edges = UBound(m_Edges)
    On Error GoTo 0
    num_edges = num_edges + 1
    ReDim Preserve m_Edges(1 To num_edges)

    ' Make the edge
    With m_Edges(num_edges)
        .Pt1 = FindPointByName(name1)
        .Pt2 = FindPointByName(name2)
    End With
End Sub
' Add an Face to the m_Faces array.
Private Sub MakeFace(ByVal name1 As String, ByVal name2 As String, ByVal name3 As String)
Dim num_faces As Integer

    ' Make room.
    On Error Resume Next
    num_faces = UBound(m_Faces)
    On Error GoTo 0
    num_faces = num_faces + 1
    ReDim Preserve m_Faces(1 To num_faces)

    ' Make the Face
    With m_Faces(num_faces)
        .Pt1 = FindPointByName(name1)
        .Pt2 = FindPointByName(name2)
        .Pt3 = FindPointByName(name3)
    End With
End Sub
' Add a Triangle to the m_Triangles array.
Private Sub MakeTriangle(ByVal Pt1 As Integer, ByVal Pt2 As Integer, ByVal Pt3 As Integer)
Dim num_triangles As Integer

    ' Make room.
    On Error Resume Next
    num_triangles = UBound(m_Triangles)
    On Error GoTo 0
    num_triangles = num_triangles + 1
    ReDim Preserve m_Triangles(1 To num_triangles)

    ' Make the Triangle
    With m_Triangles(num_triangles)
        .Pt1 = Pt1
        .Pt2 = Pt2
        .Pt3 = Pt3
    End With
End Sub
' Add a point to the m_Points array.
Private Function MakePoint(ByVal new_name As String, ByVal X As Single, ByVal Y As Single, ByVal Z As Single) As Integer
Dim num_points As Integer

    ' Make room.
    On Error Resume Next
    num_points = UBound(m_Points)
    On Error GoTo 0
    num_points = num_points + 1
    ReDim Preserve m_Points(1 To num_points)

    ' Create the point.
    With m_Points(num_points)
        .Name = new_name
        .X = X
        .Y = Y
        .Z = Z
    End With

    MakePoint = num_points
End Function
' Add a point to the m_Points array.
Private Function MakeNormalizedPoint(ByVal new_name As String, ByVal X As Single, ByVal Y As Single, ByVal Z As Single) As Integer
Dim dist As Single

    ' Make the point distance Z1 from the origin.
    dist = Sqr(X * X + Y * Y + Z * Z)
    X = X / dist * Z1
    Y = Y / dist * Z1
    Z = Z / dist * Z1

    ' Make the point.
    MakeNormalizedPoint = MakePoint(new_name, X, Y, Z)
End Function
